/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v2

import (
	v1 "github.com/kyverno/kyverno/pkg/client/applyconfigurations/kyverno/v1"
)

// RuleContextApplyConfiguration represents an declarative configuration of the RuleContext type for use
// with apply.
type RuleContextApplyConfiguration struct {
	Rule             *string                            `json:"rule,omitempty"`
	DeleteDownstream *bool                              `json:"deleteDownstream,omitempty"`
	Synchronize      *bool                              `json:"synchronize,omitempty"`
	Trigger          *v1.ResourceSpecApplyConfiguration `json:"trigger,omitempty"`
}

// RuleContextApplyConfiguration constructs an declarative configuration of the RuleContext type for use with
// apply.
func RuleContext() *RuleContextApplyConfiguration {
	return &RuleContextApplyConfiguration{}
}

// WithRule sets the Rule field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Rule field is set to the value of the last call.
func (b *RuleContextApplyConfiguration) WithRule(value string) *RuleContextApplyConfiguration {
	b.Rule = &value
	return b
}

// WithDeleteDownstream sets the DeleteDownstream field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the DeleteDownstream field is set to the value of the last call.
func (b *RuleContextApplyConfiguration) WithDeleteDownstream(value bool) *RuleContextApplyConfiguration {
	b.DeleteDownstream = &value
	return b
}

// WithSynchronize sets the Synchronize field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Synchronize field is set to the value of the last call.
func (b *RuleContextApplyConfiguration) WithSynchronize(value bool) *RuleContextApplyConfiguration {
	b.Synchronize = &value
	return b
}

// WithTrigger sets the Trigger field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Trigger field is set to the value of the last call.
func (b *RuleContextApplyConfiguration) WithTrigger(value *v1.ResourceSpecApplyConfiguration) *RuleContextApplyConfiguration {
	b.Trigger = value
	return b
}
